 Rem File: IO5.bas - Dndutil.bas
 Rem $Include: 'dndutil.inc'
 Rem $Include: 'datim.bi'

Function Timeit!
 ' ticks = 18.20648
 If LINUX Then
    InregsX.AX = &H0
    CALL InterruptX(&H1A, InregsX, OutregsX) ' bios time
    Byte1! = Csng(OutregsX.CX)
    Byte2! = Csng(OutregsX.DX)
    IF Byte1! < 0! THEN Byte1! = Byte1! + 65536! ' adjust signed-integer
    IF Byte2! < 0! THEN Byte2! = Byte2! + 65536!
    ByteX! = Byte1! * &H10000 + Byte2!
    ByteX! = ByteX! / 18.20648 ' calculate ticks per second
    Timeit! = ByteX!
    Exit Function
 Endif
 Timeit!=Timer
 Exit Function
End Function

Function DateS$
 On Local Error Goto FdateErr1
 DateS$=Format$(Now,"mm-dd-yyyy")
FdateResume1:
 Exit Function
FdateErr1:
 Tmp1$=Left$(DATE$,6)+"2099"
 VarY$=Mid$(Date$,7,4) ' mm-dd-yyyy
 If Left$(VarY$,2)="20" Then
    VarX=Int(Val(Mid$(VarY$,3,2)))
    If VarX>=79 And VarX<=99 Then
       Tmp1$=Left$(DATE$,6)+VarY$ ' 2079-2099
    Endif
 Endif
 DateS$=Tmp1$
 Resume FdateResume1
End Function

' define clock string function
Function FClock$
 On Local Error Goto FclockErr1
 FClock$=Format$(Now,"ddd dd mmm yyyy\, hh:mma/p")
FclockResume1:
 Exit Function
FclockErr1:
 Tmp1$=Left$(DATE$,6)+"2099"
 VarY$=Mid$(Date$,7,4) ' mm-dd-yyyy
 If Left$(VarY$,2)="20" Then
    VarX=Int(Val(Mid$(VarY$,3,2)))
    If VarX>=79 And VarX<=99 Then
       Tmp1$=Left$(DATE$,6)+VarY$ ' 2079-2099
    Endif
 Endif
 Fclock$=Tmp1$+", "+TIME$
 Resume FclockResume1
End Function

' define value to formatted string function
Function Form$(Var#)
 Form$=Format$(Var#,"#,##0;;"+Chr$(34)+"zero"+Chr$(34))
End Function

' define function to compare times
Function Time.Elapsed(Start.Time!,Wait.Time!)
 Elapsed.Time!=Timeit!-Start.Time!
 ' test past midnight
 If Elapsed.Time!<SFalse Then
    Elapsed.Time!=Elapsed.Time!+86400!
 Endif
 If Elapsed.Time!>Wait.Time! Then
    Time.Elapsed=True
 Else
    Time.Elapsed=False
 Endif
End Function

' define function to compare serialized times
Function SerialTimeElapsed(Serial.Start.Time#,Serial.Wait.Time#)
 Start.Time!=Csng(Hour(Serial.Start.Time#))*3600!
 Start.Time!=Start.Time!+Csng(Minute(Serial.Start.Time#))*60!
 Start.Time!=Start.Time!+Csng(Second(Serial.Start.Time#))

 Wait.Time!=Csng(Hour(Serial.Wait.Time#))*3600!
 Wait.Time!=Wait.Time!+Csng(Minute(Serial.Wait.Time#))*60!
 Wait.Time!=Wait.Time!+Csng(Second(Serial.Wait.Time#))

 Elapsed.Time!=Timeit!-Start.Time!
 ' test past midnight
 If Elapsed.Time!<SFalse Then
    Elapsed.Time!=Elapsed.Time!+86400!
 Endif
 ' compare time
 If Elapsed.Time!>=Wait.Time! Then
    SerialTimeElapsed=True
 Else
    SerialTimeElapsed=False
 Endif
End Function
